
// CN[h
#include <windows.h>
#include <stdio.h>

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#include <AR/ar.h>
#include <AR/param.h>
#include <AR/video.h>
#include <AR/gsub.h>
#include <AR/arvrml.h>


// Cu
#pragma comment(lib,"libAR.lib")
#pragma comment(lib,"libARgsub.lib")
#pragma comment(lib,"libARvideo.lib")
#pragma comment(lib,"libARvrml.lib")
#pragma comment(lib,"openvrml.lib")
#pragma comment(lib,"openvrml-gl.lib")
#pragma comment(lib,"antlr.lib")
#pragma comment(lib,"regex.lib")
#pragma comment(lib,"libjpeg.lib")
#pragma comment(lib,"libpng.lib")
#pragma comment(lib,"zlib.lib")
#pragma comment(lib,"ws2_32.lib")


// O[oϐ
char	*vconf_name		= "Data/WDM_camera_flipV.xml";	// rfIfoCX̐ݒt@C
char	*cparam_name    = "Data/camera_para.dat";		// Jp[^t@C
char	*patt_name      = "Data/patt.ver2";				// p^[t@C
char	*vrml_name		= "Data/ver2.dat";				// VRML̐ݒt@C

int		vrml_id;						// VRMLID
int		patt_id;						// p^[ID
double	patt_trans[3][4];				// Wϊs
double	patt_center[2]	= { 0.0, 0.0 };	// p^[̒SW
double	patt_width		= 80.0;			// p^[̃TCYiPʁFmmj
int		thresh			= 100;			// 2l臒l


// vg^Cv錾
void MainLoop(void);
void DrawObject(void);
void KeyEvent(unsigned char key, int x, int y);
void Cleanup(void);


//===========================================================================
// main֐
//===========================================================================
int main( int argc, char **argv )
{
	ARParam	cparam;			// Jp[^
	ARParam	wparam;			// Jp[^iƗpϐj
	int		xsize, ysize;	// 摜TCY

	// GLUT̏
	glutInit( &argc, argv );

	// rfIfoCX̐ݒ
	if ( arVideoOpen( vconf_name ) < 0 ) {
		printf("rfIfoCX̃G[");
		return -1;
	}

	// Jp[^̐ݒ
	if ( arVideoInqSize( &xsize, &ysize ) < 0 ) {
		printf("摜TCY擾ł܂ł\n");
		return -1;
	}
	if ( arParamLoad( cparam_name, 1, &wparam ) < 0 ) {
		printf("Jp[^̓ǂݍ݂Ɏs܂\n");
		return -1;
	}
	arParamChangeSize( &wparam, xsize, ysize, &cparam );
	arInitCparam( &cparam );

	// p^[t@C̃[h
	if ( (patt_id = arLoadPatt(patt_name)) < 0 ) {
		printf("p^[t@C̓ǂݍ݂Ɏs܂\n");
		return -1;
	}

	// VRML̓ǂݍ
	printf("VRML̓ǂݍݒ...");
	if ( (vrml_id = arVrmlLoadFile(vrml_name)) < 0 ) {
		printf("VRMLt@C̓ǂݍ݂Ɏs܂\n");
		return -1;
	}
	printf("\n");

	// EBhE̐ݒ
	argInit( &cparam, 1.0, 0, 0, 0, 0 );
	glutSetWindowTitle("2.0 on ARToolKit");

	// rfILv`̊Jn
	arVideoCapStart();

	// I֐̐ݒ
	atexit( Cleanup );

	// C[v̊Jn
	argMainLoop( NULL, KeyEvent, MainLoop );

	return 0;
}


//===========================================================================
// C[v֐
//===========================================================================
void MainLoop(void)
{
	ARUint8			*image;
	ARMarkerInfo	*marker_info;
	int				marker_num;
	int				j, k;

	// J摜̎擾
	if ( (image = arVideoGetImage()) == NULL ) {
		arUtilSleep( 2 );
		return;
	}

	// VRMLp^C}̍XV
	arVrmlTimerUpdate();

	// J摜̕`
	argDrawMode2D();
	argDispImage( image, 0, 0 );

	// }[J̌oƔF
	if ( arDetectMarker( image, thresh, &marker_info, &marker_num ) < 0 ) {
		Cleanup();
		exit(0);
	}

	// ̉摜̃Lv`w
	arVideoCapNext();

	// }[J̐Mx̔r
	k = -1;
	for( j = 0; j < marker_num; j++ ) {
		if ( patt_id == marker_info[j].id ) {
			if ( k == -1 ) k = j;
			else if ( marker_info[k].cf < marker_info[j].cf ) k = j;
		}
	}

	if ( k != -1 ) {
		// }[J̈ʒuEpiWϊsǰvZ
		arGetTransMat( &marker_info[k], patt_center, patt_width, patt_trans );

		// 3DIuWFNg̕`
		DrawObject();
	}

	// obt@̓eʂɕ\
	argSwapBuffers();
}


//===========================================================================
// 3DIuWFNg̕`s֐
//===========================================================================
void DrawObject(void)
{
	double	gl_para[16];

	// 3DIuWFNg`悷邽߂̏
	argDrawMode3D();
	argDraw3dCamera( 0, 0 );

	// Wϊs̓Kp
	argConvGlpara( patt_trans, gl_para );
	glMatrixMode( GL_MODELVIEW );
	glLoadMatrixd( gl_para );

	// 3DIuWFNg̕`
	glClear( GL_DEPTH_BUFFER_BIT );		// Zobt@̏
	glEnable( GL_DEPTH_TEST );			// Bʏ̓Kp

	glPushMatrix();
		arVrmlDraw(vrml_id);				// VRML̕`
	glPopMatrix();

	glDisable( GL_DEPTH_TEST );

}


//===========================================================================
// L[{[h͏֐
//===========================================================================
void KeyEvent( unsigned char key, int x, int y)
{
	switch ( key ) {
		case 0x1b:
		case 'Q':
		case 'q':
			exit(0);
	}
}


//===========================================================================
// I֐
//===========================================================================
void Cleanup(void)
{
    arVideoCapStop();		// rfILv`̒~
    arVideoClose();			// rfIfoCX̏I
    argCleanup();			// OtBbN̏I
	arVrmlFree(vrml_id);	// VRML̊J
}